<template>
  <nav
    class="navbar has-shadow is-fixed-top"
    role="navigation"
    aria-label="main navigation"
  >
    <TheHamburgerButton @click="sideNav = !sideNav" />
    <TheSideNav v-show="sideNav" @close-sidenav="sideNav = !sideNav" />
    <div class="navbar-brand">
      <nuxt-link to="/" class="navbar-item">
        <span>{{ $siteConfig.siteName }}</span>
      </nuxt-link>
    </div>

    <div
      :class="{
        'navbar-menu': true,
        'is-active': active,
      }"
    >
      <ul class="navbar-links">
        <li
          v-for="item in $siteConfig.mainMenu"
          :key="item.link"
          class="navbar-item"
          @click="active = false"
        >
          <nuxt-link :to="item.link">{{ item.name }}</nuxt-link>
        </li>
        <li v-if="isLoggedIn" class="navbar-item">
          <AppButton @click="logout">Logout</AppButton>
        </li>
        <li v-else class="navbar-item">
          <nuxt-link to="/admin/auth">Login</nuxt-link>
        </li>
      </ul>
    </div>
  </nav>
</template>
<script>
export default {
  data() {
    return {
      active: false,
      image: '',
      sideNav: false,
    }
  },
  computed: {
    isLoggedIn() {
      return this.$store.state.auth.token
    },
  },
  mounted() {
    this.$store.dispatch('auth/validateAuth')
  },
  methods: {
    logout() {
      this.$store.dispatch('auth/logout').then(() => {
        this.$router.push('/admin/auth')
      })
    },
  },
}
</script>
<style scoped>
.navbar.is-fixed-top {
  top: 0;
  left: 0;
  position: fixed;
  right: 0;
  z-index: 30;
  display: flex;
  background-color: #fff;
  height: 60px;
  justify-content: flex-start;
}
.navbar.has-shadow {
  box-shadow: 0 2px 0 0 #f5f5f5;
}
.navbar-brand {
  align-items: stretch;
  display: flex;
  flex-shrink: 0;
  min-height: 3.25rem;
  font-size: 1.4rem;
}
a.navbar-item {
  cursor: pointer;
  align-items: center;
  text-decoration: none;
}
.navbar-links {
  margin-left: auto;
  align-items: stretch;
  display: none;
}
@media (min-width: 768px) {
  .navbar-links {
    display: flex;
  }
  .navbar.is-fixed-top {
    justify-content: space-between;
  }
}
.navbar-item {
  color: #4a4a4a;
  display: flex;
  line-height: 1.5;
  padding: 0 0.75rem;
  position: relative;
}
.navbar-item img {
  max-height: 3.5rem;
}
.navbar-burger {
  height: auto;
}
.navbar-menu {
  display: flex;
  margin: auto 0px;
}
.navbar-menu a {
  display: block;
  font-weight: bold;
  text-decoration: none;
}
.navbar-item a:hover,
a.nuxt-link-exact-active {
  color: black;
}
</style>
